///////////////////////////////////////////////////////////////////////////////////////////////
//CtWsort.c
//geschrieben und compiliert mit MinGw, also eigentlich gcc. Ja, wenn jemand einen Teil des
//codes etwas verwenden mchte wre ne Erwhnung schn, aber ansonsten eigentlich nichts.
//	"g++.exe -x c++ -c D:\CtWsort.c -o D:\CtWsort.o  -Wall -fpermissive -O3  -fconserve-space"
//	"g++.exe  D:\CtWsort.o -o D:\CtWsort.exe  -Wall -fpermissive -O3  -Wl,-s"
////////////////////////////////
//Der Grundgedanke:
//Alle Teile werden rotiert und aussoriert, bis keine Duplikate brig sind.
//diese Rorationsstufen der Teile werden, durch den ganzen wrfel "geschoben", bis sie an einer
//Stelle eingepasst werden knnnen. So werden alle Teile (hier Object genannt) Mit Backtracing
//eingepasst.
////////////////////////////////
//Umsetzung:
//ein Object ist eine Kette die einen Teil des Puzzels reprsentiert der in alle mglichen
//Stellungen rotiert worden ist.
//Der Wrfel wird in 3 MMX Registern gehalten, jedes reprsentiert eine Eben, des Wrfels.
//Eine Ebene ist in 4 WORD unterteilt (je 16 bit).
//Ein WORD ist wie folgt aufgeteilt  _O_O_O_O_O######               #=nicht benutzt
//                                                                  _="berlaufflag"
//                                                                  O=ein Stein der 5er Reihe
//Mit dieser Speicherbelegung knnen Objecte schnell im Wrfel verschoben werden (hoff ich
//jetzt mal :-) ) und neue Objecte hienein-addiert werden. Bei einer berschneidung wird das
//"berlaufflag" gesetzt. So kann das Backtracing ein erfolgreiches Einfgen testen.
//PS: der GCC-Assembler ist "verkehrtherum"
//
//V2:
//DualProcessor Support :-), sollte es auch fr hyperthreading tun
//
///////////////////////////////////////////////////////////////////////////////////////////////
#define tracedepth 11/*11*/
#define wieviel 11
///////////////////////////////////////////////////////////////////////////////////////////////



//#define false 0									Fr mich :-)
//#define true 1
#define transerr 2
	
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>
typedef unsigned short	WORD;
typedef unsigned char BYTE;
#define Line WORD 
#define LOBYTE(w)	((BYTE)(w))
#define HIBYTE(w)	((BYTE)(((WORD)(w)>>8)&0xFF)) 
typedef int					xySize[3]; 
typedef int					Unit[3];
typedef struct Quadr{Line				Quad[3][4]; 
						   xySize 			dim;
						   xySize 			curpos;
							struct 			Quadr *nEntry;};


// kleine <windows.h>
typedef unsigned long DWORD; 
typedef unsigned long HANDLE;
typedef const char *LPCCH,*PCSTR,*LPCSTR; 
typedef void *PVOID,*LPVOID; 
typedef struct _SECURITY_ATTRIBUTES {	DWORD nLength;	LPVOID lpSecurityDescriptor;
						bool bInheritHandle;} SECURITY_ATTRIBUTES,*LPSECURITY_ATTRIBUTES; 
#define INFINITE	0xFFFFFFFF
#define WINAPI __stdcall 
extern "C" {
HANDLE WINAPI CreateMutexA(LPSECURITY_ATTRIBUTES,bool,LPCSTR);
bool WINAPI CloseHandle(HANDLE);
#define CreateMutex CreateMutexA
DWORD WINAPI WaitForSingleObject(HANDLE,DWORD);
bool WINAPI ReleaseMutex(HANDLE);
}


///Functions
void insObjs2(Quadr *in,int unt,int dep);
void insObjs(Quadr *in,int unt,int dep);
void filterdopp(Quadr *in);
void rotate(Quadr *in);
void printq(Quadr *out,bool debug);
int MMXinit();
bool MMXcompare(Quadr *in,Quadr *test);
void MMXload(Quadr *in);
void MMXsave(Quadr *out);
void MMXprintf(int mmxreg);
bool MMXmovex(int x);
bool MMXmovey(int y);
bool MMXadd(Quadr *in,int z,int y,int x);
void setUnit(Quadr *out,int z,int y,int x);
bool getUnit(Quadr *out,int z,int y,int x);
void CreatePart(Quadr *out,Unit nodes[],int i);
bool RotX270(Quadr *out);
bool RotX180(Quadr *out);
bool RotX090(Quadr *out);
bool RotY270(Quadr *out);
bool RotY180(Quadr *out);
bool RotY090(Quadr *out);
bool RotZ270(Quadr *out);
bool RotZ180(Quadr *out);
bool RotZ090(Quadr *out);

///Vars
unsigned short MASK[4]	  ={0xAA80,0xAA80,0xAA80,0xAA80}; // siehe oben(Bits): _O_O_O_O_O######
unsigned short IFOK[4]	  ={0x0000,0x0000,0x0000,0x0000};
// Die Puzzelteile
Unit Unit00[]={{0,0,0},{0,0,1},{0,1,0},{0,2,0},{0,2,1}};
Unit Unit01[]={{0,2,0},{0,0,1},{0,0,2},{0,2,1},{0,1,1}};
Unit Unit02[]={{0,0,0},{0,1,0},{0,0,1},{0,0,2},{0,0,3}};
Unit Unit03[]={{0,0,0},{0,1,2},{0,0,1},{0,0,2},{0,0,3}};
Unit Unit04[]={{0,0,0},{0,1,0},{0,0,1},{1,0,0},{1,0,1}};
Unit Unit05[]={{0,0,1},{0,1,1},{0,2,1},{0,0,0},{0,0,2}};
Unit Unit06[]={{0,0,0},{0,0,1},{0,0,2},{0,1,0},{0,1,1}};
Unit Unit07[]={{0,2,0},{0,0,1},{0,0,2},{0,1,0},{0,1,1}};
Unit Unit08[]={{0,0,0},{0,0,1},{0,1,0},{1,0,1}};
Unit Unit09[]={{0,1,0},{0,1,1},{0,1,2},{0,0,2},{0,2,1}};
Unit Unit10[]={{0,1,0},{0,1,1},{0,1,2},{0,0,1},{0,2,1}};
Unit Unit11[]={{0,0,0},{0,0,1},{0,1,0},{0,2,0},{0,2,1},{0,3,0}};


WORD	masksWGood[5] = {0x4000,0x1000,0x400,0x100,0x40}; // Bitmaske
WORD	masksWBAD[6]  = {0x8000,0x2000,0x800,0x200,0x80,0x3F}; //Bitmaske
Unit maxdim={2,3,4}; ///!!! Dimesntion ist immer 1 kleiner als wirklich wegen 0 !!!
Quadr *Objects[12],*Objects2[12];//Objeckte
Quadr *Bak[12],*Bak2[12];// damit die rekursive Funktion nicht immer Specher holen muss.
Quadr *CtW;// DER Wrfel
Quadr *Test;//??
HANDLE print;
bool scndthread=true;
int succs=0;// gefundene Lsungen
int					ctrl[12]={0,0,0,0,0,0,0,0,0,0,0,0}; // Anzah der Rotationen
////////////////////////////////////////////////////////////////////////////////////
// Object wird rotiert und an des ende seiner Kette gehngt
// Wichtig, dimension dim und die Bndigkeit zu den 0 Koordinaten
bool RotX270(Quadr *in){
Quadr *Temp;
Temp = (Quadr *) malloc(sizeof(Quadr));
memset (Temp, 0x00, sizeof(Quadr));
//DimentionCheck
Temp->dim[0]=in->dim[1];
Temp->dim[1]=in->dim[0];
Temp->dim[2]=in->dim[2];
if (Temp->dim[0]>maxdim[0]) return 1;
if (Temp->dim[1]>maxdim[1]) return 1;


for (int z=0;z<=in->dim[0];z++)
	for (int i=0;i<=in->dim[1];i++)
		for (int j=0;j<=in->dim[2];j++)
			if (getUnit(in,z,i,j)) setUnit(Temp,i,in->dim[0]-z,j);

while (in->nEntry!=NULL) in=in->nEntry;
in->nEntry=Temp;

return 0;}
////////////////////////////////////////////////////////////////////////////////////
// Object wird rotiert und an des ende seiner Kette gehngt
// Wichtig, dimension dim und die Bndigkeit zu den 0 Koordinaten
bool RotX180(Quadr *in){
Quadr *Temp;
Temp = (Quadr *) malloc(sizeof(Quadr));
memset (Temp, 0x00, sizeof(Quadr));
//DimentionCheck
Temp->dim[0]=in->dim[0];
Temp->dim[1]=in->dim[1];
Temp->dim[2]=in->dim[2];



for (int z=0;z<=in->dim[0];z++)
	for (int i=0;i<=in->dim[1];i++)
		for (int j=0;j<=in->dim[2];j++)
			if (getUnit(in,z,i,j)) setUnit(Temp,in->dim[0]-z,in->dim[1]-i,j);

while (in->nEntry!=NULL) in=in->nEntry;
in->nEntry=Temp;

return 0;}
////////////////////////////////////////////////////////////////////////////////////
// Object wird rotiert und an des ende seiner Kette gehngt
// Wichtig, dimension dim und die Bndigkeit zu den 0 Koordinaten
bool RotX090(Quadr *in){
Quadr *Temp;
Temp = (Quadr *) malloc(sizeof(Quadr));
memset (Temp, 0x00, sizeof(Quadr));
//DimentionCheck
Temp->dim[0]=in->dim[1];
Temp->dim[1]=in->dim[0];
Temp->dim[2]=in->dim[2];
if (Temp->dim[0]>maxdim[0]) return 1;
if (Temp->dim[1]>maxdim[1]) return 1;


for (int z=0;z<=in->dim[0];z++)
	for (int i=0;i<=in->dim[1];i++)
		for (int j=0;j<=in->dim[2];j++)
			if (getUnit(in,z,i,j)) setUnit(Temp,in->dim[1]-i,z,j);

while (in->nEntry!=NULL) in=in->nEntry;
in->nEntry=Temp;

return 0;}
////////////////////////////////////////////////////////////////////////////////////
// Object wird rotiert und an des ende seiner Kette gehngt
// Wichtig, dimension dim und die Bndigkeit zu den 0 Koordinaten
bool RotY270(Quadr *in){
Quadr *Temp;
Temp = (Quadr *) malloc(sizeof(Quadr));
memset (Temp, 0x00, sizeof(Quadr));
//DimentionCheck
Temp->dim[0]=in->dim[2];
Temp->dim[1]=in->dim[1];
Temp->dim[2]=in->dim[0];
if (Temp->dim[0]>maxdim[0]) return 1;
if (Temp->dim[2]>maxdim[2]) return 1;


for (int z=0;z<=in->dim[0];z++)
	for (int i=0;i<=in->dim[1];i++)
		for (int j=0;j<=in->dim[2];j++)
			if (getUnit(in,z,i,j)) setUnit(Temp,j,i,in->dim[0]-z);

while (in->nEntry!=NULL) in=in->nEntry;
in->nEntry=Temp;

return 0;}
////////////////////////////////////////////////////////////////////////////////////
// Object wird rotiert und an des ende seiner Kette gehngt
// Wichtig, dimension dim und die Bndigkeit zu den 0 Koordinaten
bool RotY180(Quadr *in){
Quadr *Temp;
Temp = (Quadr *) malloc(sizeof(Quadr));
memset (Temp, 0x00, sizeof(Quadr));
//DimentionCheck
Temp->dim[0]=in->dim[0];
Temp->dim[1]=in->dim[1];
Temp->dim[2]=in->dim[2];



for (int z=0;z<=in->dim[0];z++)
	for (int i=0;i<=in->dim[1];i++)
		for (int j=0;j<=in->dim[2];j++)
			if (getUnit(in,z,i,j)) setUnit(Temp,in->dim[0]-z,i,in->dim[2]-j);

while (in->nEntry!=NULL) in=in->nEntry;
in->nEntry=Temp;

return 0;}
////////////////////////////////////////////////////////////////////////////////////
// Object wird rotiert und an des ende seiner Kette gehngt
// Wichtig, dimension dim und die Bndigkeit zu den 0 Koordinaten
bool RotY090(Quadr *in){
Quadr *Temp;
Temp = (Quadr *) malloc(sizeof(Quadr));
memset (Temp, 0x00, sizeof(Quadr));
//DimentionCheck
Temp->dim[0]=in->dim[2];
Temp->dim[1]=in->dim[1];
Temp->dim[2]=in->dim[0];
if (Temp->dim[0]>maxdim[0]) return 1;
if (Temp->dim[2]>maxdim[2]) return 1;


for (int z=0;z<=in->dim[0];z++)
	for (int i=0;i<=in->dim[1];i++)
		for (int j=0;j<=in->dim[2];j++)
			if (getUnit(in,z,i,j)) setUnit(Temp,in->dim[2]-j,i,z);

while (in->nEntry!=NULL) in=in->nEntry;
in->nEntry=Temp;

return 0;}
//////////////////////////////////////////////////////////////////////////////////////////
// Fr mich zum debuggen zeigt den inhalt des mit mmxreg spezifizierten MMX-Registers an
void MMXprintf(int mmxreg){
WORD temp[4];
switch (mmxreg){case 0 :
						asm (" movq		%%mm0,%0    " : "=m" (temp));
					   break;
					 case 1 :
						asm (" movq		%%mm1,%0    " : "=m" (temp));
					   break;
					 case 2 :
						asm (" movq		%%mm2,%0    " : "=m" (temp));
					   break;
					 case 3 :
						asm (" movq		%%mm3,%0    " : "=m" (temp));
					   break;
					 case 4 :
						asm (" movq		%%mm4,%0    " : "=m" (temp));
					   break;
					 case 5 :
						asm (" movq		%%mm5,%0    " : "=m" (temp));
					   break;
					 case 6 :
						asm (" movq		%%mm6,%0    " : "=m" (temp));
					   break;
				    case 7 :
						asm (" movq		%%mm7,%0    " : "=m" (temp));
					   break;}
for (int vat=0;vat<4;++vat) {printf ("%4d %4d",HIBYTE(temp[vat]),LOBYTE(temp[vat]));};printf ("\n");	
}
////////////////////////////////////////////////////////////////////////////////////////7
// Ld einen Wrfel in mmx0-2
void MMXload(Quadr *in){
asm (" movq		%0,%%mm0    " : "=m" (in->Quad[0]));		
asm (" movq		%0,%%mm1    " : "=m" (in->Quad[1]));		
asm (" movq		%0,%%mm2    " : "=m" (in->Quad[2]));		
}
////////////////////////////////////////////////////////////////////////////////////////7

// Spechert einen Wrfel vom mmx 0-2 nach out

void MMXsave(Quadr *out){
asm (" movq		%%mm0,%0    " : "=m" (out->Quad[0]));		
asm (" movq		%%mm1,%0    " : "=m" (out->Quad[1]));		
asm (" movq		%%mm2,%0    " : "=m" (out->Quad[2]));		
}




/////////////////////////////////////////////////////////////////////////////////////////
//Verschiebt eine Wrfel der in mmx 3-5 liegt entlang der Y Achse
bool MMXmovey(int y){
switch (y){case 0 :										
					   break;
			  case 1 :
						asm (" psllq    $16,%mm3");
						asm (" psllq    $16,%mm4");
						asm (" psllq    $16,%mm5");
						break;
			  case 2 :
						asm (" psllq    $32,%mm3");
						asm (" psllq    $32,%mm4");
						asm (" psllq    $32,%mm5");
						break;						 
			  case 3 :
						asm (" psllq    $48,%mm3");
						asm (" psllq    $48,%mm4");
						asm (" psllq    $48,%mm5");
						break;						 						 						 
			  default :
			  				return false;
	}
return true;
}
////////////////////////////////////////////////////////////////////////////////////
//Verschiebt eine Wrfel der in mmx 3-5 liegt entlang der X Achse
bool MMXmovex(int x){
switch (x){case 0 :										
					   break;
			  case 1 :
						asm (" psrlw    $2,%mm3");
						asm (" psrlw    $2,%mm4");
						asm (" psrlw    $2,%mm5");
						break;
			  case 2 :
						asm (" psrlw    $4,%mm3");
						asm (" psrlw    $4,%mm4");
						asm (" psrlw    $4,%mm5");
                  break;
           case 3 :
						asm (" psrlw    $6,%mm3");
						asm (" psrlw    $6,%mm4");
						asm (" psrlw    $6,%mm5");
						break;
			  case 4 :
						asm (" psrlw    $8,%mm3");
						asm (" psrlw    $8,%mm4");
						asm (" psrlw    $8,%mm5");
                  break;
			  default :
			  				return false;
	}
return true;
}
////////////////////////////////////////////////////////////////////////////////////
// in Wird auf MMX 0-2 an der vorgegebene Position (z,y,x) eingefgt ("aufaddiert")
// return : TRUE = erfolgreich eingefgt
//
// Weiter Optimierungsmglichkeit: Die Maske in mmx6 kann ganz leicht durch pxor mmx6,mmx6
// erzeugt werden also ist es nicht dauern belegt. Die meisten Tests dieser function hier sind
// Negativ.Wenn man das Ergebis ber mmx6 (dann mmx3, mmx4, mmx5) im Specher hlt muss der
// "VortestWrfel" nicht immer aus dem Specher geladen werden, allerdings wrde diese nderung
// die Translate Funktionen komplizieren und bei einem erfolgreichen Test mehr Zeit beanspruchen
bool MMXadd(Quadr *in,int z,int y,int x){

//----Translate Teil (Pov-Ray user wissen wovon ich spreche :-) )
unsigned int test;
switch (z){case 0 :
						asm (" movq		%0,%%mm3    " : "=m" (in->Quad[0]));		
						asm (" movq		%0,%%mm4    " : "=m" (in->Quad[1]));		
						asm (" movq		%0,%%mm5    " : "=m" (in->Quad[2]));
						if (!MMXmovex(x) || !MMXmovey(y)) {return transerr;break;}
						asm (" paddw	%mm3,%mm0");
						asm (" paddw	%mm4,%mm1");
						asm (" paddw	%mm5,%mm2");										
					   break;
			  case 1 :
			  			asm (" movq		%0,%%mm3    " : "=m" (in->Quad[0]));		
						asm (" movq		%0,%%mm4    " : "=m" (in->Quad[1]));
						if (!MMXmovex(x) || !MMXmovey(y)) {return transerr;break;}	
						asm (" paddw	%mm3,%mm1");
						asm (" paddw	%mm4,%mm2");
						break;
			  case 2 :
			  			asm (" movq		%0,%%mm3    " : "=m" (in->Quad[0]));
						if (!MMXmovex(x) || !MMXmovey(y)) {return transerr;break;}
						asm (" paddw	%mm3,%mm2");			  
                  break;
			  default :
			  				return transerr;
											
	}

//------------------------------------------------
//----Verleich ob eine berlappung vorliegt
//mgliche berlappungen herausfiltern
asm (" movq		%mm0,%mm3");
asm (" movq		%mm1,%mm4");
asm (" movq		%mm2,%mm5");
asm (" pand    %mm7,%mm3");
asm (" pand    %mm7,%mm4");
asm (" pand    %mm7,%mm5");
//zusammenlegen
asm (" por    %mm3,%mm5");
asm (" por    %mm4,%mm5");
//ergebnis verdoppeln
asm (" movq		%mm5,%mm4");
//vergleichen ob berlappungen drin waren und in 32 Bit form bringen
asm (" psrlq    $32,%mm4");
asm (" pcmpeqd	%mm6,%mm4");
asm (" pcmpeqd	%mm6,%mm5");
asm (" pand    %mm4,%mm5");
asm (" movd	%%mm5,%0    " : "=m" (test));
if (test!=0) return true; else return false;

}
////////////////////////////////////////////////////////////////////////////////////
// Object wird rotiert und an das Ende seiner Kette gehngt
// Wichtig, dimension dim und die Bndigkeit zu den 0 Koordinaten
bool RotZ270(Quadr *in){
Quadr *Temp;
Temp = (Quadr *) malloc(sizeof(Quadr));
memset (Temp, 0x00, sizeof(Quadr));
//DimentionCheck
Temp->dim[0]=in->dim[0];
Temp->dim[1]=in->dim[2];
Temp->dim[2]=in->dim[1];
if (Temp->dim[1]>maxdim[1]) return 1;
if (Temp->dim[2]>maxdim[2]) return 1;

for (int z=0;z<=in->dim[0];z++)
	for (int i=0;i<=in->dim[1];i++)
		for (int j=0;j<=in->dim[2];j++)
			if (getUnit(in,z,i,j)) setUnit(Temp,z,j,in->dim[1]-i);

while (in->nEntry!=NULL) in=in->nEntry;
in->nEntry=Temp;

return 0;}
////////////////////////////////////////////////////////////////////////////////////
// Object wird rotiert und an des ende seiner Kette gehngt
// Wichtig, dimension dim und die Bndigkeit zu den 0 Koordinaten
bool RotZ180(Quadr *in){
Quadr *Temp;
Temp = (Quadr *) malloc(sizeof(Quadr));
memset (Temp, 0x00, sizeof(Quadr));
//DimentionCheck
Temp->dim[0]=in->dim[0];
Temp->dim[1]=in->dim[1];
Temp->dim[2]=in->dim[2];


for (int z=0;z<=in->dim[0];z++)
	for (int i=0;i<=in->dim[1];i++)
		for (int j=0;j<=in->dim[2];j++)
			if (getUnit(in,z,i,j)) setUnit(Temp,z,in->dim[1]-i,in->dim[2]-j);

while (in->nEntry!=NULL) in=in->nEntry;
in->nEntry=Temp;

return 0;}
////////////////////////////////////////////////////////////////////////////////////
// Object wird rotiert und an des ende seiner Kette gehngt
// Wichtig, dimension dim und die Bndigkeit zu den 0 Koordinaten
bool RotZ090(Quadr *in){
Quadr *Temp;
Temp = (Quadr *) malloc(sizeof(Quadr));
memset (Temp, 0x00, sizeof(Quadr));
//DimentionCheck
Temp->dim[0]=in->dim[0];
Temp->dim[2]=in->dim[1];
Temp->dim[1]=in->dim[2];
if (Temp->dim[1]>maxdim[1]) return 1;
if (Temp->dim[2]>maxdim[2]) return 1;


for (int z=0;z<=in->dim[0];z++)
	for (int i=0;i<=in->dim[1];i++)
		for (int j=0;j<=in->dim[2];j++)
			if (getUnit(in,z,i,j)) setUnit(Temp,z,in->dim[2]-j,i);

while (in->nEntry!=NULL) in=in->nEntry;
in->nEntry=Temp;

return 0;}
////////////////////////////////////////////////////////////////////////////////////
//Puzzel Stcke in Object Struktur bringen
// Quadr = Object
// noes  = Steine des Puzzelstcks
// i     = Anzahl der Puzzelstcke
void CreatePart(Quadr *out,Unit nodes[],int i){
int myz=0,myy=0,myx=0;
i/=sizeof(Unit);
for (int j=0;j<i;j++) {setUnit(out,nodes[j][0],nodes[j][1],nodes[j][2]);
							  if (nodes[j][0]>myz)myz=nodes[j][0];
							  if (nodes[j][1]>myy)myy=nodes[j][1];
							  if (nodes[j][2]>myx)myx=nodes[j][2];
								}
out->dim[0]=myz;
out->dim[1]=myy;
out->dim[2]=myx;
}
////////////////////////////////////////////////////////////////////////////////7
// schaune ob mmx da ist und gleich Masken laden
int MMXinit()
{
	 unsigned int mmxc= 0x00800000;
	 int tt;
					 asm (".byte 0xb8,0x01,0x00,0x00,0x00");    // mov eax, 00000001
              	 asm (".byte 0x0f, 0xa2"						  // CPUID
                    : "=d" (tt)	:	: "eax");								  // mov ref, edx   (eax trashed) wegen Speed optimierung
					 if ((tt & mmxc)==mmxc) {
						 		asm (" movq		%0,%%mm7    " : "=m" (MASK));
						 		asm (" movq		%0,%%mm6    " : "=m" (IFOK));
						 		return 1;}
					   else  return 0;
}
/////////////////////////////////////////////////////////////////
// Einen Stein in einer Object Structur setzen
void setUnit(Quadr *out,int z,int y,int x){
out->Quad[z][y]=(out->Quad[z][y] | masksWGood[x]);

}
/////////////////////////////////////////////////////////////////
// Einen Stein aus einer Object Structur holen
bool getUnit(Quadr *out,int z,int y,int x){
if ((out->Quad[z][y] & masksWGood[x])==masksWGood[x]) return true; else return false;

}
//////////////////////////////////////////////////////////////////////////
// Ausgabe einer Object Kette ab dem gegebene Eintrag
// debug fr mich
void printq	 	(Quadr *out,bool debug){

if (out==NULL) {printf("\nEnde der Kette!\n"); return;}
printf("\n%20s %20s %20s\n%8s","0ste Ebene:","1te Ebene:","2te Ebene:\n","");

for (int j=0;j<4;j++){
		for (int i=0;i<5;i++) if ((out->Quad[0][j] & masksWGood[i]) == masksWGood[i]) printf("  X"); else printf("  _");
		printf("%6s","");	
		for (int i=0;i<5;i++) if ((out->Quad[1][j] & masksWGood[i]) == masksWGood[i]) printf("  X"); else printf("  _");
		printf("%5s","");
		for (int i=0;i<5;i++) if ((out->Quad[2][j] & masksWGood[i]) == masksWGood[i]) printf("  X"); else printf("  _");
		printf("\n%8s","");}	

if (debug){
	printf("\nDebug Info:\n\n%8s","");
	printf("\nz:%i",out->dim[0]);
	printf("\ny:%i",out->dim[1]);
	printf("\nx:%i",out->dim[2]);
	for (int j=0;j<4;j++){
		for (int i=0;i<6;i++) if ((out->Quad[0][j] & masksWBAD[i]) == masksWBAD[i]) printf("  X"); else printf("  _");
		printf("%3s","");	
		for (int i=0;i<6;i++) if ((out->Quad[1][j] & masksWBAD[i]) == masksWBAD[i]) printf("  X"); else printf("  _");
		printf("%2s","");
		for (int i=0;i<6;i++) if ((out->Quad[2][j] & masksWBAD[i]) == masksWBAD[i]) printf("  X"); else printf("  _");
		printf("\n%8s","");}
			}
printq(out->nEntry,debug);
	}
////////////////////////////////////////////////////////////////////////////////////////77
// Objekte rotieren, Ich weiss sie werden zu oft gedreht, aber von Zeitaufwand vertretbar
void rotate(Quadr *in){
int c=0;
Quadr *Temp,*Temp2;

Temp2=Temp=in;

RotZ090(in);
RotZ180(in);
RotZ270(in);

while (Temp->nEntry!=NULL) {Temp=Temp->nEntry;c++;}
for (int i=0;i<=c;i++){RotX090(in);
							  RotX180(in);
							  RotX270(in);
							  in=in->nEntry;	}
in=Temp2;
c=0;
while (Temp2->nEntry!=NULL) {Temp2=Temp2->nEntry;c++;}
for (int i=0;i<=c;i++){RotY090(in);
							  RotY180(in);
							  RotY270(in);
							  in=in->nEntry;	}
}
////////////////////////////////////////////////////////////////////////////////////////77
// doppelte eintrge finden
//
// returns false if different
// returns true if ==
bool MMXcompare(Quadr *in,Quadr *test){
MMXload(in);
unsigned int result;
asm (" movq		%0,%%mm3    " : "=m" (test->Quad[0]));		
asm (" movq		%0,%%mm4    " : "=m" (test->Quad[1]));		
asm (" movq		%0,%%mm5    " : "=m" (test->Quad[2]));
asm (" paddw	%mm3,%mm0");
asm (" paddw	%mm4,%mm1");
asm (" paddw	%mm5,%mm2");
asm (" movq		%mm7,%mm3");
asm (" psllq    $1,%mm3");
asm (" pand    %mm3,%mm0");
asm (" pand    %mm3,%mm1");
asm (" pand    %mm3,%mm2");
asm (" por    %mm1,%mm0");
asm (" por    %mm2,%mm0");
//ergebnis verdoppeln
asm (" movq		%mm0,%mm1");
//vergleichen ob berlappungen drin waren und in 32 Bit form bringen
asm (" psrlq    $32,%mm0");
asm (" pcmpeqd	%mm6,%mm0");
asm (" pcmpeqd	%mm6,%mm1");
asm (" pand    %mm0,%mm1");
asm (" movd	%%mm1,%0    " : "=m" (result));
if (result!=0) return true; else return false;
}
////////////////////////////////////////////////////////////////////////////////////////77
// doppelte, Rotationsstufen filtern Eintrag aus der Kette lschen wenn doppelt
//
void filterdopp(Quadr *in){
Quadr *back;


back=in;

while (back->nEntry!=NULL){
	while (in->nEntry!=NULL) 
		if (MMXcompare(back,in->nEntry)) in->nEntry=in->nEntry->nEntry;
			                         else in=in->nEntry;
back=back->nEntry;
if (back==NULL) return; //wenn der Eintrag gerade erst gendert worden ist.
in=back;}

}
////////////////////////////////////////////////////////////////////////////////////////////
///rekursiver Hauptteil, ein Object wird mit all seinen Rorationsstufen in alle fr diese 
//mglichen Possitionen "eingepasst"
//Quadr = Stuktur die auf die original Teile zeigt
//unt = Teil das gerade bearbeitet wird
//sucdep = grsse bei der abgebrochen wird
void insObjs(Quadr *in[12],int unt,int sucdep){
Quadr *PointBak;
			
PointBak=in[unt];
if (unt==sucdep+1) { // +1 vielleicht noch durch > anstelle von == ersetzen
																			 WaitForSingleObject(print,INFINITE);							 
																			 succs++;
																			 printf("\n!!---New Solution Thread 1---!!\n");
																			 MMXsave(Test);
																			 for (int d=1;d<unt;d++) printq(Bak[d],false);
																			 printq(Test,false);
																			 printf("\ndepth:%i\n",sucdep);
																			 printf("\ngefundene Loesungen:%i\n",succs);
																			 //getch();
																			 ReleaseMutex( print );
	return;}  //nur mit allen 11(12) machbar, sonst muss noch weiter gecheckt werden

while (in[unt]!=NULL){ //noch Rotationsstufen vorhanden?
for (in[unt]->curpos[2]=maxdim[2]-in[unt]->dim[2];in[unt]->curpos[2]>=0;in[unt]->curpos[2]--){
	for (in[unt]->curpos[1]=maxdim[1]-in[unt]->dim[1];in[unt]->curpos[1]>=0;in[unt]->curpos[1]--){
		for (in[unt]->curpos[0]=maxdim[0]-in[unt]->dim[0];in[unt]->curpos[0]>=0;in[unt]->curpos[0]--){
			MMXsave(Bak[unt]);
			if 
			(MMXadd(in[unt],in[unt]->curpos[0],in[unt]->curpos[1],in[unt]->curpos[2]))
																		{							
 																			insObjs(Objects,unt+1,sucdep);
																			MMXload(Bak[unt]);
																			}else
																		{
																			MMXload(Bak[unt]);
																			}
		}
	}
}
in[unt]=in[unt]->nEntry;  // das Object wird eine Rotatinsstufe vorgeschoben

											//Bisschen mehr Info "damit man sieht das es noch luft :-)"
										/*	WaitForSingleObject(print,INFINITE);
											printf("Thread 1");
											ctrl[unt]=ctrl[unt]+1; 
											if (unt<=wieviel) {
											for (int t=0;t<=wieviel;t++)
											printf("%2i:%2i ",t,ctrl[t]);
											printf("\n");
											getch();
											ReleaseMutex( print );
											}*/

}
in[unt]=PointBak;
//ctrl[unt]=0;
return;}

////////////////////////////////////////////////////////////////////////////////////////////
///rekursiver Hauptteil, ein Object wird mit all seinen Rorationsstufen in alle fr diese 
//mglichen Possitionen "eingepasst"
//Quadr = Stuktur die auf die original Teile zeigt
//unt = Teil das gerade bearbeitet wird
//sucdep = grsse bei der abgebrochen wird
void insObjs2(Quadr *in[12],int unt,int sucdep){
Quadr *PointBak;
			
PointBak=in[unt];
if (unt==sucdep+1) { // +1 vielleicht noch durch > anstelle von == ersetzen
																			 WaitForSingleObject(print,INFINITE);
																			 succs++;
																			 printf("\n!!---New Solution Thread 2---!!\n");
																			 MMXsave(Test);
																			 for (int d=1;d<unt;d++) printq(Bak2[d],false);
																			 printq(Test,false);
																			 printf("\ndepth:%i\n",sucdep);
																			 printf("\ngefundene Loesungen:%i\n",succs);
																			 //getch();
																			 ReleaseMutex( print );
	return;}  //nur mit allen 11(12) machbar, sonst muss noch weiter gecheckt werden

while (in[unt]!=NULL){ //noch Rotationsstufen vorhanden?
for (in[unt]->curpos[2]=maxdim[2]-in[unt]->dim[2];in[unt]->curpos[2]>=0;in[unt]->curpos[2]--){
	for (in[unt]->curpos[1]=maxdim[1]-in[unt]->dim[1];in[unt]->curpos[1]>=0;in[unt]->curpos[1]--){
		for (in[unt]->curpos[0]=maxdim[0]-in[unt]->dim[0];in[unt]->curpos[0]>=0;in[unt]->curpos[0]--){
			MMXsave(Bak2[unt]);
			if 
			(MMXadd(in[unt],in[unt]->curpos[0],in[unt]->curpos[1],in[unt]->curpos[2]))
																		{							
 																			insObjs2(Objects2,unt+1,sucdep);
																			MMXload(Bak2[unt]);
																			}else
																		{
																			MMXload(Bak2[unt]);
																			}
		}
	}
}
in[unt]=in[unt]->nEntry;  // das Object wird eine Rotatinsstufe vorgeschoben

											//Bisschen mehr Info "damit man sieht das es noch luft :-)"
										/*	WaitForSingleObject(print,INFINITE);
											printf("Thread 2");
											ctrl[unt]=ctrl[unt]+1; 
											if (unt<=wieviel) {
											for (int t=0;t<=wieviel;t++)
											printf("%2i:%2i ",t,ctrl[t]);
											printf("\n");
											getch();
											ReleaseMutex( print );
											}*/

}
in[unt]=PointBak;
//ctrl[unt]=0;
return;}
////////////////////////////////////////////////////////////////////////////////////////77
void scndth(void *ss){

if (MMXinit()) printf("2nd MMX da, alles okay...\n"); else {printf("Kauf dich MMX in deinen 2ten Processor ehhh :-)...\n");
																		  getch();exit(0);}
MMXload(CtW);
insObjs2(Objects2,0,tracedepth);
asm (".byte 0x0f, 0x77"	);  //emms
scndthread=false; //Fetig!
}
////////////////////////////////////////////////////////////////////////////////////////77
int main(){
//INIT
Quadr *info;
int infoc;

Test = (Quadr *) malloc(sizeof(Quadr));
memset (Test, 0x00, sizeof(Quadr));
CtW = (Quadr *) malloc(sizeof(Quadr));
memset (CtW, 0x00, sizeof(Quadr));
for (int i=0;i<12;i++){
	Objects[i] = (Quadr *) malloc(sizeof(Quadr));
	memset (Objects[i], 0x00, sizeof(Quadr));
	Bak[i] = (Quadr *) malloc(sizeof(Quadr));
	memset (Bak[i], 0x00, sizeof(Quadr));
	Objects2[i] = (Quadr *) malloc(sizeof(Quadr));
	memset (Objects2[i], 0x00, sizeof(Quadr));
	Bak2[i] = (Quadr *) malloc(sizeof(Quadr));
	memset (Bak2[i], 0x00, sizeof(Quadr));
}

if (MMXinit()) printf("MMX da, alles okay...\n"); else {printf("Kauf dich MMX...\n");
																		  getch();exit(0);}
print = CreateMutex( NULL, false, NULL );
printf("Creating Objects...\n");
// Teile in Bit Form bringen
CreatePart(Objects[0],Unit00,sizeof(Unit00));
CreatePart(Objects[1],Unit01,sizeof(Unit01));
CreatePart(Objects[2],Unit02,sizeof(Unit02));
CreatePart(Objects[3],Unit03,sizeof(Unit03));
CreatePart(Objects[4],Unit04,sizeof(Unit04));
CreatePart(Objects[5],Unit05,sizeof(Unit05));
CreatePart(Objects[6],Unit06,sizeof(Unit06));
CreatePart(Objects[7],Unit07,sizeof(Unit07));
CreatePart(Objects[8],Unit08,sizeof(Unit08));
CreatePart(Objects[9],Unit09,sizeof(Unit09));
CreatePart(Objects[10],Unit10,sizeof(Unit10));
CreatePart(Objects[11],Unit11,sizeof(Unit11));

CreatePart(Objects2[0],Unit00,sizeof(Unit00));
CreatePart(Objects2[1],Unit01,sizeof(Unit01));
CreatePart(Objects2[2],Unit02,sizeof(Unit02));
CreatePart(Objects2[3],Unit03,sizeof(Unit03));
CreatePart(Objects2[4],Unit04,sizeof(Unit04));
CreatePart(Objects2[5],Unit05,sizeof(Unit05));
CreatePart(Objects2[6],Unit06,sizeof(Unit06));
CreatePart(Objects2[7],Unit07,sizeof(Unit07));
CreatePart(Objects2[8],Unit08,sizeof(Unit08));
CreatePart(Objects2[9],Unit09,sizeof(Unit09));
CreatePart(Objects2[10],Unit10,sizeof(Unit10));
CreatePart(Objects2[11],Unit11,sizeof(Unit11));
printf("Rotating Objects...\n");
// Teile rotieren, doppelte rauswerfen
for (int i=0;i<12;i++)		{rotate(Objects[i]);
									 filterdopp(Objects[i]);
									 rotate(Objects2[i]);
									 filterdopp(Objects2[i]);}
printf("moeglicht Rotations-Positionen der Objecte\n");
for (int i=0;i<12;i++){info=Objects[i];infoc=1;
							 while (info->nEntry!=NULL) {info=info->nEntry;infoc++;}
							 printf("     Object %2i hat %2i\n",i,infoc);
								}
// Arbeit aufteilen
Objects2[0]=Objects2[0]->nEntry->nEntry->nEntry->nEntry->nEntry->nEntry;
Objects[0]->nEntry->nEntry->nEntry->nEntry->nEntry->nEntry=NULL;
//--------------------------------------------------------------------------------------------
//MAIN
unsigned long ThreadID; 


ThreadID = _beginthread( scndth,0x100000, NULL ); 
sleep(50); //Wait for 2nd Thread init

MMXload(CtW);//Leeren Wrfel laden
insObjs(Objects,0,tracedepth);//Starten

while (scndthread) {sleep(50);} //Falls 2ter thread noch Zeit braucht
printf("\nLoesungen insgesammt: %i\n",succs);
//--------------------------------------------------------------------------------------------
///EXIT
getch();
asm (".byte 0x0f, 0x77"	);             // emms (mmx aufrumen)
CloseHandle( print );
free(Test);
free(CtW);
for (int i=0;i<12;i++){free(Objects[i]);free(Bak[i]);
							  free(Objects2[i]);free(Bak2[i]);} //ich weiss :-/
}